TEMPLATE = app
TARGET = libremediaserver-audio

QT += webkitwidgets widgets

CONFIG += debug
DESTDIR = ./debug

HEADERS += libremediaserver-audio.h \
    medialibrary.h \
    olathread.h \
    audiolayerwidget.h \
    dmxPersonality.h \
    audiowidget.h \
    audiomasterwidget.h \
    defines.h \
    settings.h \
    settingsdialog.h

SOURCES += main.cpp \
           libremediaserver-audio.cpp \
    medialibrary.cpp \
    olathread.cpp \
    audiolayerwidget.cpp \
    audiowidget.cpp \
    audiomasterwidget.cpp \
    settings.cpp \
    settingsdialog.cpp

FORMS += \
    libremediaserver-audio.ui

LIBS += -lola -lolacommon

RESOURCES =

OTHER_FILES += \
    ../LICENSE.txt \
    ../instalacion.txt \
    ../credits.txt \
    ../compiling.txt \
    ../changelog.txt \
    ../lms-audio.xlm

win32:CONFIG(release, debug|release): LIBS += -L$$PWD/SFML/lib/release/ -lsfml-audio
else:win32:CONFIG(debug, debug|release): LIBS += -L$$PWD/SFML/lib/debug/ -lsfml-audio
else:symbian: LIBS += -lsfml-audio
else:unix: LIBS += -L$$PWD/SFML/lib/ -lsfml-audio -lsfml-system

INCLUDEPATH += $$PWD/SFML/include
DEPENDPATH += $$PWD/SFML/include
